local ui = {}
--local vars = dofile('vars.lua')
ui.DEFAULTS_COLOR = '\127a0a0a0'
ui.MAX_NUM_PORTS = 7

local vars = dofile('vars.lua')

--* Begin UI *--

local main_button = iup.stationbutton{title="Open SLM", action=function() SLM.ui:Show() end}
local loc = StationEquipmentTab[1][1][1][1][1][2][1][2][1][1][1][1][1][1][3][1][1][3]
--local loc = StationEquipmentTab[1][1][1][1][1][2][1][1][1][2]
--iup.Detach(loc[2])
loc[2].size=2
iup.Append(loc, main_button)
iup.Append(loc, iup.fill{})
--iup.Append(loc, loc[2])
--loc.gap=2
--iup.Map(StationEquipmentTab)
--iup.Refresh(StationEquipmentTab)

--iup.Append(StationEquipmentTab[1][1][1][1][1][2][1][1][1][2], main_button)

-- Main GUI --

ui.element = {} --iup controls
ui.pane = {} --groupings of iup controls

ui.element.close_button = iup.stationbutton{title="Close", expand="HORIZONTAL"}

-- Presets Tab --

ui.presets = {}
ui.presets.element = {}

ui.presets.element.name_label = iup.label{title="Preset Name: ", expand="No"}
ui.presets.element.name = iup.label{title="", expand="Horizontal"}
ui.presets.element.ship_label = iup.label{title="Ship: ", expand="No"}
ui.presets.element.ship = iup.label{title="", expand="Horizontal"}

ui.presets.element.addons_label = iup.label{title="Addons:", expand="No"}
ui.presets.element.addons_box = {}
ui.presets.element.addons = {}
ui.presets.element.addon_imgs = {}
for i=1,ui.MAX_NUM_PORTS do
	ui.presets.element.addon_imgs[i] = iup.label{title="", image=""}
	ui.presets.element.addons[i] = iup.label{title="none", expand="Horizontal"}
	
	ui.presets.element.addons_box[i] = iup.hbox{ui.presets.element.addon_imgs[i], ui.presets.element.addons[i]}
end

ui.presets.element.price_label = iup.label{title="Price: "}
ui.presets.element.price = iup.label{title=""}
ui.presets.element.sector_label = iup.label{title=""}
ui.presets.element.station_label = iup.label{title=""}

ui.presets.element.rename_button = iup.stationbutton{title="Rename"}
ui.presets.element.delete_button = iup.stationbutton{title="Delete Preset"}
--ui.presets.element.save_color_button = iup.stationbutton{title="Save Color"} --TODO
ui.presets.element.buy_button = iup.stationbutton{title="Buy Preset"}

ui.presets.element.default_buttons = {}
ui.presets.element.default_labels = {}
ui.presets.element.preset_buttons = {}
ui.presets.element.preset_labels = {}
ui.pane.preset_buttons = iup.hbox{gap=2}
for i=1,4 do
	local width = math.floor(189+((gkinterface.GetXResolution() or 800) - 800)/4)
	ui.presets.element.default_buttons[i] = iup.stationbutton{title="Assign Default "..i, size=width.."x"}
	ui.presets.element.default_labels[i] = iup.label{title="", size=width.."x", alignment="ACENTER"}
	ui.presets.element.preset_buttons[i] = iup.stationbutton{title="Assign Preset "..i, size=width.."x"}
	ui.presets.element.preset_labels[i] = iup.label{title="", size=width.."x", alignment="ACENTER"}
	
	iup.Append(ui.pane.preset_buttons, iup.vbox{ui.presets.element.preset_buttons[i], ui.presets.element.preset_labels[i], ui.presets.element.default_buttons[i], ui.presets.element.default_labels[i]})
end

ui.presets.element.preset_list = iup.pdasubsubsublist{value=0, size="240x360"}


ui.pane.preset_info = iup.vbox{
	iup.hbox{ui.presets.element.name_label, ui.presets.element.name},
	iup.hbox{ui.presets.element.ship_label, ui.presets.element.ship},
	iup.fill{size=22},
	ui.presets.element.addons_label,
	iup.hbox{iup.vbox(ui.presets.element.addons_box),iup.fill{}}, --TODO add color picker
	iup.fill{size=22},
	iup.hbox{ui.presets.element.price_label, ui.presets.element.price},
	iup.fill{},
	expand="NO",
}

ui.presets.tab = iup.vbox{
	iup.hbox{ui.pane.preset_info, iup.fill{}, ui.presets.element.preset_list, gap=8},
	iup.hbox{ui.presets.element.sector_label, ui.presets.element.station_label, iup.fill{}, ui.presets.element.rename_button, ui.presets.element.delete_button, iup.fill{size=12}, ui.presets.element.buy_button},
	iup.fill{size=6},
	iup.hbox{ui.pane.preset_buttons, iup.fill{size=4}},
	--margin="10x20",
	tabtitle="Presets",
	hotkey=iup.K_P,
}

function ui.presets.element.rename_button:action()
	local preset_name = filter_colorcodes(ui.GetListSelected(ui.presets.element.preset_list)):match("^%**(.*)")
	
	if preset_name~=nil then
		local rename_cb = function(name)
			if SLM:rename{preset_name, name} then
				--Regenerate Preset button text --TODO: only update text that changed
				if PlayerInStation() and not GetStationType() then --not in capship
					local stationid = GetStationLocation()
					local station_presets = SLM.data.stations[stationid] and SLM.data.stations[stationid] or {}
		
					for i=1,4 do
						if station_presets[i] then
							local color = SLM.GetLoadoutColor(SLM.data.presets[ station_presets[i] ]) or ''
							ui.presets.element.preset_labels[i].title = color..station_presets[i]
						else ui.presets.element.preset_labels[i].title = "UNASSIGNED" end
					end
				end
				
				--update name in list
				local list_sel = ui.presets.element.preset_list.vo_listsel
				local color = SLM.GetLoadoutColor(SLM.data.presets[name]) or '\127ffffff'
				ui.presets.element.preset_list[list_sel] = color..name --change name in list
				ui.UpdateListSelection() --update loadout info panel
				iup.Refresh(ui.dialog)
			end
		end
		
		local rename_dlg = ui.MakeRenameDialog(rename_cb, false, preset_name)
		ShowDialog(rename_dlg,iup.CENTER,iup.CENTER)
	end
end

function ui.presets.element.delete_button:action()
	local function ok_cb()
		local preset_name = filter_colorcodes(ui.GetListSelected(ui.presets.element.preset_list)):match("^%**(.*)")
		
		if preset_name~=nil then
			if SLM:delete{preset_name} then
				ui.LoadPresets() --TODO: More elegant method
				
				--[[ (redundant with LoadPresets)
				--update list
				local item_num = ui.presets.element.preset_list.vo_listsel
				ui.RemoveListItem(ui.presets.element.preset_list, item_num) --remove deleted entry
				ui.presets.element.preset_list.value = item_num-1 --select entry above
				ui.UpdateListSelection() --update loadout info panel
				
				iup.Refresh(ui.dialog)]]
			end
		end
		
		HideDialog(QuestionDialog)
	end

	local function cancel_cb()
		HideDialog(QuestionDialog)
	end

	QuestionDialog:SetMessage("Are you sure you want to delete this loadout?\nIt will be removed from ALL stations", "Ok", ok_cb, "Cancel", cancel_cb)
	ShowDialog(QuestionDialog)
end

function ui.presets.element.buy_button:action()
	local preset_name = filter_colorcodes(ui.GetListSelected(ui.presets.element.preset_list)):match("^%**(.*)")
	local loadout = SLM.GetLoadout(preset_name)
	
	local function ok_cb()
		ui:Hide()
		SLM:buy{preset_name}
		
		HideDialog(QuestionDialog)
	end
	
	local function cancel_cb()
		HideDialog(QuestionDialog)
	end
	
	if not SLM.CheckAvailability(loadout) then
		QuestionDialog:SetMessage("Not all items for this loadout are available at this station.\nAre you sure you want to buy it?", "Ok", ok_cb, "Cancel", cancel_cb)
		ShowDialog(QuestionDialog)
	else ok_cb() end --make purchase w/o confirmation
end

--Assign presets/defaults button actions
for i=1,4 do
	ui.presets.element.preset_buttons[i].action = function()
		local preset_name = filter_colorcodes(ui.GetListSelected(ui.presets.element.preset_list)):match("^%**(.*)")
		local loadout = SLM.GetLoadout(preset_name)
		local color = SLM.GetLoadoutColor(loadout) or ''
		
		if SLM.data.presets[preset_name]~=nil then
			if SLM:assign{i, preset_name} then
				ui.presets.element.preset_labels[i].title = color..(preset_name or "#ERROR")
				iup.Refresh(ui.dialog)
			end
		else
			local assign_preset_cb = function(name)
				if SLM:save{i, name, loadout} then
					ui.presets.element.preset_labels[i].title = color..(name or "#ERROR")
					ui.LoadPresets() --to add to list --TODO: more elegant method
					iup.Refresh(ui.dialog)
				end
			end
			
			local rename_dlg = ui.MakeRenameDialog(assign_preset_cb, false)
			ShowDialog(rename_dlg,iup.CENTER,iup.CENTER)
		end
		
		iup.Refresh(ui.dialog)
	end
	
	ui.presets.element.default_buttons[i].action = function()
		local preset_name = filter_colorcodes(ui.GetListSelected(ui.presets.element.preset_list)):match("^%**(.*)")
		local loadout = SLM.GetLoadout(preset_name)
		
		if SLM.data.presets[preset_name]~=nil then
			if SLM:assign{"DEFAULT"..i, preset_name} then
				ui.presets.element.default_labels[i].title = ui.DEFAULTS_COLOR..(SLM.GetTruncatedShipName(loadout) or "#ERROR")
				iup.Refresh(ui.dialog)
			end
		else
			--if SLM:save{"DEFAULT"..i, preset_name, loadout} then --obsolete
			SLM.DoDefaultAssignment(loadout, i) --TODO use safer function
			ui.presets.element.default_labels[i].title = ui.DEFAULTS_COLOR..(SLM.GetTruncatedShipName(loadout) or "#ERROR")
			iup.Refresh(ui.dialog)
		end	
	end
end

function ui.presets.element.preset_list:action(item, n, sel)
	if sel==1 then ui.UpdateListSelection(item, n) end
end

function ui.UpdateListSelection(item, n)
	item = item or ui.GetListSelected(ui.presets.element.preset_list)
	n = n or ui.presets.element.preset_list.value
	
	ui.presets.element.name.title = item
	local preset_name = filter_colorcodes(item or ''):match("^%**(.*)")
	local loadout = SLM.GetLoadout(preset_name) --SLM.data.presets[preset_name]
	
	if loadout then
		ui.presets.element.ship.title = InvManager.GetInventoryItemParameter(loadout.ship, 'Name')
		ui.presets.element.price.title = string.gsub(comma_value(SLM.CheckAvailability(loadout)) or "NOT AVAILABLE", '(%d+)$', '%1 cr')
		
		--TODO: make more elegant
		--assign addon names
		for i=1,ui.MAX_NUM_PORTS do
			ui.presets.element.addon_imgs[i].image = ''
			ui.presets.element.addons[i].title = 'none'
		end
		for i,itemtypeid in ipairs(loadout.ports) do
			local addon_name = InvManager.GetInventoryItemParameter(itemtypeid, 'Name') or 'none'
			iup.SetAttribute(ui.presets.element.addon_imgs[i], "IMAGE", InvManager.GetInventoryItemParameter(itemtypeid, 'Icon') or '')
			ui.presets.element.addons[i].title = addon_name
		end
		
		for i=1,4 do
			ui.presets.element.preset_buttons[i].active = PlayerInStation() and "YES" or "NO"
			ui.presets.element.default_buttons[i].active = "YES"
		end
		ui.presets.element.buy_button.active = "YES"
		
	else --e.g. no active ship
		ui.presets.element.ship.title = "No Ship"
		ui.presets.element.price.title = "NOT AVAILABLE"
		for i=1,ui.MAX_NUM_PORTS do
			ui.presets.element.addon_imgs[i].image = ''
			ui.presets.element.addons[i].title = 'none'
		end
		
		--disable buttons because loadout is invalid
		for i=1,4 do
			ui.presets.element.preset_buttons[i].active = "NO"
			ui.presets.element.default_buttons[i].active = "NO"
		end
		ui.presets.element.buy_button.active = "NO"
	end
	
	--disable rename/delete buttons for special loadouts
	if SLM.data.presets[preset_name] then
		ui.presets.element.rename_button.active = "YES"
		ui.presets.element.delete_button.active = "YES"
	else
		ui.presets.element.rename_button.active = "NO"
		ui.presets.element.delete_button.active = "NO"
	end
	
	iup.Map(ui.dialog)
	iup.Refresh(ui.dialog)
end

function ui.presets.tab:OnHelp()
	StationHelpDialog:Open(
[[You can manage your list of saved ship presets from this dialog window.

The list on the right shows all your saved loadouts. Select a preset to see info about which ship and addons are used in the preset (shown on the left side of the dialog). Loadouts in which not all items are available at the current station are prefaced with *.

The buttons apply to the loadout selected from the list:
*Rename: Allows you to change the name of an existing preset at all stations where it is used (20 characters max)
*Delete Preset: Removes the selected loadout and deletes it from all stations where it is currently assigned (default loadouts will be used instead). Default loadouts, as well as the loadout of your active ship cannot be deleted.
*Buy Preset: Purchases the selected loadout and makes it your active ship. The ship and addons must be available at the current station.

You can use the buttons along the bottom to assign a loadout as a preset for the current station. The 'Assign Preset #' button will assign the loadout to the current station in slot #. You can also assign it as a default loadout to all stations with the 'Assign Default #' button. Stations that don't have a preset assigned will use the defaults instead.

Loadout Naming Conventions:
*Name cannot be longer than 20 characters
*Name must contain at least one non-numeric character
*Name cannot begin with * or #
*Each loadout must have a unique name (but a loadout can be assigned to more than one station)
*There are additional reserved names that cannot be used

Loadout data is saved in ]].."/settings/"..(GetPlayerName() or 'NAME').."/system"..SLM.NOTES.main.."notes.txt")
end

-- Options Tab --

ui.options = {}
ui.options.element = {}
ui.options.pane = {}

ui.options.element.use_color_toggle = iup.stationtoggle{title="Use ship color for preset names"}
ui.options.element.backup_button = iup.stationbutton{title="Backup Presets"}
ui.options.element.restore_button = iup.stationbutton{title="Restore Presets"}
ui.options.element.backup_info = iup.label{title="", FGCOLOR="150 150 150"}
ui.options.element.restore_info = iup.label{title="", FGCOLOR="150 150 150"}
ui.options.element.backup_file_loc = iup.label{title="/settings/"..(GetPlayerName() or 'NAME').."/system"..SLM.NOTES.bak.."notes.txt"}
ui.options.pane.backup = iup.vbox{
	iup.label{title="Backup & Restoration"},
	iup.hbox{ui.options.element.backup_button, ui.options.element.backup_info, iup.fill{}, gap=4},
	iup.hbox{ui.options.element.restore_button, ui.options.element.restore_info, iup.fill{}, gap=4},
	ui.options.element.backup_file_loc,
}

--sort presets popup
ui.options.element.sort_presets_popup = iup.list{dropdown="YES"}
local popup_vals = {"Preset Name", "Ship Name", "Availability", "Price",}
for i,v in ipairs(popup_vals) do ui.options.element.sort_presets_popup[i]=v end

ui.options.tab = iup.vbox{
	ui.options.element.use_color_toggle,
	iup.hbox{iup.label{title="Sort Presets By: "}, ui.options.element.sort_presets_popup, iup.fill{}},
	iup.fill{size=30},
	ui.options.pane.backup,
	tabtitle="Options",
	hotkey=iup.K_O,
}

function ui.options.element.use_color_toggle:action()
	local bool = self.value=="ON"
	vars.isUseColor = bool
	
	gkini.WriteInt("SLM", "UseColor", bool and 1 or 0)
	
	ui.LoadPresets()
	SLM.replace_station_titles()
	SLM.replace_buyback_titles()
end

function ui.options.element.sort_presets_popup:action(item, n, sel)
	if sel==1 then
		SLM.vars.SortPresetsBy = n
		gkini.WriteInt("SLM", "SortPresetsBy", n)
		
		ui.LoadPresets()
	end
end

function ui.options.element.backup_button:action()
	if SLM.SaveData(SLM.NOTES.bak) then
		ui.options.element.backup_info.title = "BACKUP SAVED SUCCESSFULLY"
	else ui.options.element.backup_info.title = "ERROR" end
	
	iup.Refresh(ui.options.tab)
end

function ui.options.element.restore_button:action()
	local function ok_cb()
		if SLM.LoadData(SLM.NOTES.bak) then
			SLM.SaveData() --override existing notes
			ui.options.element.restore_info.title = "PRESETS RESTORED SUCCESSFULLY"
			
			ui.LoadPresets() --update preset list with restored data
		else --should be redundant
			SLM.LoadData() --reload original saved data
			ui.options.element.restore_info.title = "NO BACKUP DATA FOUND"
		end
		
		iup.Refresh(ui.options.tab)
		HideDialog(QuestionDialog)
	end

	local function cancel_cb()
		HideDialog(QuestionDialog)
	end
	
	local bak_data = LoadSystemNotes(SLM.NOTES.bak)
	if bak_data~='' then --verify backup data exists
		local timestamp = unspickle(bak_data).timestamp
		local date = timestamp and os.date("%c", timestamp) or "UNKNOWN"
		QuestionDialog:SetMessage("Do you want to restore presets data saved on "..date.."\nYour existing preset data will be lost", "Ok", ok_cb, "Cancel", cancel_cb)
		ShowDialog(QuestionDialog)
	else
		ui.options.element.restore_info.title = "NO BACKUP DATA FOUND"
		iup.Refresh(ui.options.tab)
	end
end

function ui.options.tab:OnHelp()
	--[[*Add button to open SLM from buy ship interface: if this option is checked then a button will be added to the Ship->Buy-Buy Ship window for convenience (while docked at station)]]
	StationHelpDialog:Open(
[[Various settings for ShipLoadoutsManager can be configured from this dialog. These settings are saved to the config file to persist after logout.

Options:
*Use ship color for preset names: if this option is checked then the text for the loadout name will match the color of the ship used in the loadout
*Sort Presets By: Select a sorting option from this dropdown menu to arrange the order that loadouts are listed.
*Backup Loadouts: Saves a second copy of all your loadout data that can restored in case you accidentaly delete a loadout or make some other error.
*Restore Loadouts: Reverts loadout data back to the last saved backup. All data from after the backup was made will be lost.
]])
end

ui.tabs = iup.subsubtabtemplate {
	ui.presets.tab,
	ui.options.tab,
}

local frame = iup.vbox{
	iup.hbox{iup.fill{}, iup.label{title="Ship Loadouts Manager",font=Font.H3}, iup.fill{}},
	iup.hbox{iup.fill{}, iup.label{title="Version "..SLM.version}}, --TODO: remove global use
	alignment="ALEFT",
}


-- Create Dialog --

ui.dialog = iup.dialog{
	iup.vbox{
		iup.fill{},
		iup.hbox{
			iup.fill{},
			iup.pdarootframe{
			--iup.stationsubframe{
				iup.vbox{
					frame,
					iup.pdasubsubsubframe2 {ui.tabs},
					ui.element.close_button,
				},
				expand="NO",
				--gap=8,
			},
			iup.fill{},
		},
		iup.fill{},
	},
	BGCOLOR = "0 0 0 160 *",
	FULLSCREEN="YES",
	RESIZE="NO",
	BORDER="NO",
	MENUBOX="YES",
	TOPMOST="YES",
	DEFAULTESC=ui.element.close_button,
	DEFAULTENTER=ui.element.close_button,
}
ui.dialog:map()

-- Display Dialog --

function ui:Show()
	if not ui.dialog then ui:Init() end
	
	ui.LoadSettings()
	ui.LoadPresets()

	ShowDialog(ui.dialog,iup.CENTER,iup.CENTER)
	--iup.Map(ui.dialog)
	iup.Refresh(ui.dialog)
end

function ui:Hide()
	ui.tabs.value=0
	HideDialog(ui.dialog)
end



function ui.element.close_button:action() ui:Hide() end


-- Name Preset Dialog --

function ui.MakeRenameDialog(ok_cb, isDefault, old_name)
	local rename_element = {}
	rename_element.input_text = iup.text{value="", size="400x", nc=20}
	rename_element.error_label = iup.label{title="", size="400", fgcolor="255 0 0"}
	rename_element.default_toggle = iup.stationtoggle{title="Save as universe-wide default", value="OFF"}
	rename_element.ok_button = iup.stationbutton{title="Save"}
	rename_element.cancel_button = iup.stationbutton{title="Cancel"}
	
	if isDefault~=nil then
		rename_element.default_toggle.value = isDefault and "ON" or "OFF"
		rename_element.default_toggle.active = "NO"
	end
	
	local rename_frame = iup.vbox{
		iup.hbox{iup.fill{}, iup.label{title=old_name and "Rename "..old_name or "Choose a name for the preset",font=Font.H3}, iup.fill{}},
		rename_element.input_text,
		rename_element.error_label,
		rename_element.default_toggle,
		iup.hbox{rename_element.cancel_button, iup.fill{}, rename_element.ok_button},
		alignment="ALEFT",
	}
	
	local dlg = iup.dialog{
		iup.vbox{
			iup.fill{},
			iup.hbox{
				iup.fill{},
				iup.pdarootframe{
				--iup.stationsubframe{
					rename_frame,
					expand="NO",
					gap=8,
				},
				iup.fill{},
			},
			iup.fill{},
		},
		BGCOLOR = "0 0 0 160 *",
		FULLSCREEN="YES",
		RESIZE="NO",
		BORDER="NO",
		MENUBOX="YES",
		TOPMOST="YES",
		DEFAULTESC=rename_element.cancel_button,
		DEFAULTENTER=rename_element.ok_button,
	}
	dlg:map()
	
	function rename_element.default_toggle:action()
		if self.value=="ON" then
			rename_element.input_text.value = "DEFAULT"
			rename_element.input_text.active = "NO"
		else
			rename_element.input_text.value = ""
			rename_element.input_text.active = "YES"
		end
	end
	
	function rename_element.ok_button:action()
		local new_name = rename_element.input_text.value
		local isValid, error_msg = SLM.VerifyName(new_name)
		
		if rename_element.default_toggle.value=="OFF" and not isValid then
			rename_element.error_label.title=error_msg
			iup.Refresh(dlg)
			
			return
		end
		
		ok_cb(new_name)
		HideDialog(dlg)
	end

	function rename_element.cancel_button:action()
		HideDialog(dlg)
	end
	
	return dlg
end

--* END UI *--

function ui.LoadSettings()
	ui.options.element.backup_info.title = ""
	ui.options.element.restore_info.title = ""
	
	ui.options.element.use_color_toggle.value = vars.isUseColor and "ON" or "OFF"
	ui.options.element.sort_presets_popup.value = vars.SortPresetsBy
end

function ui.LoadPresets()	
	ui.presets.element.preset_list[1] = nil --clear preset list
	
	--create sorted list of preset names
	local sorted_order = {} --sorted list of all loadouts
	for name,loadout in pairs(SLM.data.presets) do
		local color = SLM.GetLoadoutColor(loadout) or '\127ffffff'
		table.insert(sorted_order, color..name)
	end
	local sort_funcs = {
		['Preset Name']=function(a,b) return filter_colorcodes(a):lower():match("^%**(.*)") < filter_colorcodes(b):lower():match("^%**(.*)") end,
		['Ship Name'] = function(a,b)
			local name_a = (SLM.GetLoadout(a) or {}).ship
			local name_b = (SLM.GetLoadout(b) or {}).ship
			
			if name_a and name_b then
				return InvManager.GetInventoryItemParameter(name_a, 'Name'):lower() < InvManager.GetInventoryItemParameter(name_b, 'Name'):lower()
			else return not name_b end
		end,
		Availability=function(a,b)
			local avail_a = SLM.CheckAvailability(SLM.GetLoadout(a))
			local avail_b = SLM.CheckAvailability(SLM.GetLoadout(b))
			
			if not avail_a == not avail_b then
				return  filter_colorcodes(a):lower():match("^%**(.*)") < filter_colorcodes(b):lower():match("^%**(.*)")
			else return not avail_b end
		end,
		Price=function(a,b)
			local avail_a = SLM.CheckAvailability(SLM.GetLoadout(a))
			local avail_b = SLM.CheckAvailability(SLM.GetLoadout(b))
			
			if avail_a and avail_b then
				return  avail_a < avail_b
			elseif avail_a or avail_b then
				return not avail_b
			else return filter_colorcodes(a):lower():match("^%**(.*)") < filter_colorcodes(b):lower():match("^%**(.*)") end
		end,
	}
	
	table.sort(sorted_order, sort_funcs[popup_vals[SLM.vars.SortPresetsBy] ])
	
	--populate preset list contents
	ui.PushListItem(ui.presets.element.preset_list, '\127ffffff'.."ACTIVE SHIP")
	for _,name in ipairs(sorted_order) do
		--local new_name = SLM.CheckAvailability(SLM.GetLoadout(name))==false and '*'..name or name
		--local new_name = SLM.CheckAvailability(SLM.GetLoadout(name))==false and name:gsub('^(\127%x%x%x%x%x%x)', '%1%*') or name
		
		local new_name --with * appended for non-available loadouts
		if SLM.CheckAvailability(SLM.GetLoadout(name))==false then
			local count
			new_name, count = name:gsub('^(\127%x%x%x%x%x%x)', '%1%*')
			if count==0 then new_name = '*'..name end
		else new_name = name end
		
		ui.PushListItem(ui.presets.element.preset_list, new_name) --add items from sorted list
	end
	for i=1,4 do ui.PushListItem(ui.presets.element.preset_list, '\127ffffff'.."DEFAULT "..i) end
	
	--populate station text
	if PlayerInStation() and not GetStationType() then --not in capship
		local stationid = GetStationLocation()
		local station_presets = SLM.data.stations[stationid] and SLM.data.stations[stationid] or {}
		
		ui.presets.element.sector_label.title = ShortLocationStr(GetCurrentSectorid())..": "
		ui.presets.element.station_label.title = GetStationName(stationid)
		
		ui.presets.element.buy_button.active = "YES"
		
		for i=1,4 do
			if station_presets[i] then
				local color = SLM.GetLoadoutColor(SLM.data.presets[ station_presets[i] ]) or ''
				ui.presets.element.preset_labels[i].title = color..station_presets[i]
			else ui.presets.element.preset_labels[i].title = "UNASSIGNED" end
			
			local default_loadout = ShipPresets[i]
			if default_loadout then
				ui.presets.element.default_labels[i].title = ui.DEFAULTS_COLOR..SLM.GetTruncatedShipName(default_loadout)
			else ui.presets.element.default_labels[i].title = ui.DEFAULTS_COLOR.."UNASSIGNED" end
			
			ui.presets.element.preset_buttons[i].active = "YES"
			--ui.presets.element.default_buttons[i].active = "YES"
		end
	else
		ui.presets.element.sector_label.title = ShortLocationStr(GetCurrentSectorid())..": "
		ui.presets.element.station_label.title = "NOT DOCKED AT STATION"
		
		ui.presets.element.buy_button.active = "NO"
		
		for i=1,4 do
			ui.presets.element.preset_labels[i].title = ""
			ui.presets.element.preset_buttons[i].active = "NO"
			--ui.presets.element.default_buttons[i].active = "NO"
		end
	end
	
	ui.presets.element.preset_list.value = 1 --select first item
	--ui.presets.element.preset_list:action(ui.presets.element.preset_list[1], 1, 1) --simulate clicking list item
	ui.UpdateListSelection() --update loadout info panel
end

function ui.GetListSelected(list)
	local num = tostring(iup.GetAttribute(list, "VO_LISTSEL"))
	local val = iup.GetAttribute(list, num)
	
	return val
end

--Accurately determines what the VALUE attribute of a list should be.
function ui.GetListSize(list)
	local val = 0
	while list[val + 1] do val=val+1 end
	return val
end

--Adds an item to the end of a iup list
function ui.PushListItem(list, item)
	list.value = list.value or 0
	
	local new_val = list.value+1
	list[tostring(new_val)] = item
	--list[tostring(list.value)] = item
	list.value = new_val
	
	--list.value = list.value or 0
	--list['insertitem'..list.value+1] = item
end

--Removes the selected item from a list, returns the value of the item removed
function ui.RemoveListItem(list, sel)
	local size = ui.GetListSize(list)
	sel = sel or list.vo_listsel or size
	
	if sel~=0 then
		local item = list[tostring(sel)]
		
		while tonumber(sel) < size do
			list[sel] = list[sel+1]
			sel = sel+1
		end
		
		list[tostring(size)] = nil
		list.value = size-1
		list.vo_listsel = sel-1
		
		return item
	end
end


return ui, vars